# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import gtk
import dbus
import dbus.service

from core import config
from core.common import DBUS_NAME
from core.common import DBUS_PATH

class DBusWrapper(dbus.service.Object):
    def __init__(self, parent):
        bus_name = dbus.service.BusName(DBUS_NAME, bus=dbus.SessionBus())
        super(DBusWrapper, self).__init__(bus_name, DBUS_PATH)
        self._parent = parent

    @dbus.service.method(DBUS_NAME)
    def Init(self):
        """ Reloads CoverGloobus """
        config.load()
        self._parent.init()

    @dbus.service.method(DBUS_NAME, in_signature='u')
    def Resize(self, percent):
        """ Resizes CoverGloobus window """
        self._parent._window.scale(percent)

    @dbus.service.method(DBUS_NAME, in_signature='s')
    def SetTheme(self, path):
        """ Resizes CoverGloobus window """
        self._parent._window.init(path)

    @dbus.service.method(DBUS_NAME, in_signature='ii')
    def Move(self, x, y):
        """ Resizes CoverGloobus window """
        self._parent._window.move(x, y)
