# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import gtk
import os

from gettext import gettext as _

from core import config
from covers import GenericCover

#class Pattern(GenericCover):
class Pattern:
    __title__ = 'Pattern Search'
    __version__ = '0.1'
    __authors__ = 'Alexandr Grigorcea <cahr.gr@gmail.com>'
    __desc__ = _('Search cover in filesystem using user defined pattern')

    __local__ = True

    def get_cover(self, track):
        # <album>
        # <artis>
        # <location>
        path = self._pattern

        if path.find('<artist>') > -1:
            path = path.replace('<artist>', track.artist)
        if path.find('<album>') > -1:
            path = path.replace('<album>', track.album)
        if path.find('<location>') > -1:
            path = path.replace('<location>', track.location)

        if os.path.exists(path):
            return path
        return None

    @staticmethod
    def configure(dialog):
        vbox = dialog.get_content_area()
        vbox.set_border_width(10)
        vbox.set_size_request(350, -1)
#        LABEL_WIDTH = 120
#        ENTRY_WIDTH = 200

        box = gtk.HBox(False, 10)
        label = gtk.Label(_('Pattern') + ':')
        label.set_alignment(0,0.5)
#        label.set_size_request(LABEL_WIDTH, -1)
        pattern = gtk.Entry()
        pattern.set_text(config.get('Covers','search_pattern'))
#        pattern.set_size_request(ENTRY_WIDTH, -1)
        box.pack_start(label, False)
        box.pack_start(pattern, True)
        vbox.pack_start(box, False)

        vbox.show_all()

        if dialog.run() == gtk.RESPONSE_ACCEPT:
            config.set('Covers', 'search_pattern', pattern.get_text())
