# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import logging
import re

from urllib2 import quote
from urllib2 import urlopen
from gettext import gettext as _

from lyrics import GenericLyric

c = logging.getLogger(__name__)

URL_TEMPLATE = "http://absolutelyrics.com/lyrics/view/%s/%s/"

class absolutelyrics(GenericLyric):
    __title__ = 'AbsoluteLyrics'
    __version__ = '0.1.1'
    __authors__ = 'BadChoice <guitarboy000@gmail.com>'
    __desc__ = _('Download lyrics from AbsoluteLyrics.com')

    url = ''

    def get(self, artist, title):
        artist = quote(artist.replace(" ","_").encode('utf-8'))
        title = quote(title.replace(" ","_").encode('utf-8'))
        self.url = URL_TEMPLATE % (artist, title)
        c.debug('AbsoluteLyrics URL: ' + self.url)

        content = urlopen(self.url).read()

        regexp = re.compile ('<div id="realText">(.*)</p></div>',re.DOTALL)
        m = re.search(regexp, content)

        if m:
            lyric = m.group(1).replace("<br />", "\n")
            lyric = re.sub('</p>\s?<p.+?>','\n\n', lyric)
            lyric = re.sub('</?.+?>', '', lyric)
            return lyric
        else:
            return None

    def get_webpage(self):
        return self.url
