# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import logging

from urllib import urlencode
from urllib2 import urlopen
from xml.etree.ElementTree import XML
from gettext import gettext as _

from lyrics import GenericLyric

c = logging.getLogger(__name__)

API = 'http://api.lololyrics.com/old/getLyric?rawutf8=1&'

class lololyrics(GenericLyric):

    __title__ = 'Lololyrics'
    __version__ = '0.1'
    __authors__ = 'Alexandr Grigorcea <cahr.gr@gmail.com>'
    __desc__ = _('Download lyrics from Lololyrics.com')

    _url = ''

    def get(self, artist, title):
        url = API + urlencode({'artist': artist, 'track': title})
        c.debug('Lololyrics URL: ' + url)

        try:
            data = urlopen(url).read()
            tree = XML(data)
            status = tree.find('status')
            if status is None:
                c.error('Lololyrics: status node not found')
            elif status.text != 'OK':
                c.error('Lololyrics: status not OK')
            else:
                url = tree.find('url')
                if url is None:
                    c.error('Lololyrics: url node not found')
                else:
                    self._url = url.text

                response = tree.find('response')
                if response is None:
                    c.error('Lololyrics: response node not found')
                else:
                    return response.text

        except Exception as e:
            print e

        return None

    def get_webpage(self):
        return self._url
