# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import logging
import re

from urllib2 import quote
from urllib2 import urlopen
from gettext import gettext as _

from lyrics import GenericLyric

c = logging.getLogger(__name__)

URL_TEMPLATE = "http://lyrics.com/lyrics/%s/%s.html"

class lyricscom(GenericLyric):

    __title__ = 'Lyrics.com'
    __version__ = '0.1.1'
    __authors__ = 'BadChoice <guitarboy000@gmail.com>'
    __desc__ = _('Download lyrics from Lyrics.com')

    url = ""

    def get(self, artist, title):
        artist = quote(artist.replace(" ","-").replace("\'","").encode('utf-8'))
        title = quote(title.replace(" ","-").replace("\'","").encode('utf-8'))

        self.url = URL_TEMPLATE % (artist, title)
        c.debug('Lyrics.com URL: ' + self.url)

        content = urlopen(self.url).read()

        #the *? is non greedy so it takes just one <div
        #<div id="lyric_space"> ===> Start of the div where the song is located
        #(?:\s*?<.*?>)?                ===> Take out all the leading spaces and one <*>  (Non greedy!!!!)
        #    (?:          ==> don't count it on group
        #    \s*?         ==> leading whitespaces (Non greddy)
        #    <.*?>        ==> the <*> (Non greedy)
        #    )?           ==> one time or zero

        #(.*)         ===> The lyric
        #---<br />    ===> Match the end of the lyric

        regexp = re.compile('<div id="lyrics" class="SCREENONLY">(?:\s*?<.*?>)?(.*)---<br />',
                            re.DOTALL)
        m = re.search(regexp, content)

        if m:
            lyric = m.group(1).replace("<br />", "")
            lyric = lyric.replace("&#xD;", "").strip()
            return lyric
        else:
            return None

    def get_webpage(self):
        return self.url
