# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import logging

from urllib2 import quote
from urllib2 import urlopen

from core.utils import name_hash
from lyrics import GenericLyric

c = logging.getLogger(__name__)

URL_TEMPLATE = "http://lyrics.mirkforce.net/%s/%s.txt"

class lyricsmirkforce(GenericLyric):

    __title__ = 'lyrics.mirkforce'
    __version__ = '0.1.1'
    __authors__ = 'Alexandr Grigorcea <cahr.gr@gmail.com>'
    __desc__ = 'Download lyrics from lyrics.mirkforce.net'

    url = ""

    def get(self, artist, title):
        artist = quote(name_hash(artist, True))
        title = quote(name_hash(title))

        self.url = URL_TEMPLATE % (artist, title)
        c.debug('lyrics.mirkforce URL: ' + self.url)
        try:
            return urlopen(self.url).read()
        except:
            return None

    def get_webpage(self):
        return self.url
