# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import logging
import re

from urllib2 import quote
from urllib2 import urlopen

from lyrics import GenericLyric

c = logging.getLogger(__name__)

URL_TEMPLATE = 'http://www.lyricsvip.com/%s/%s-Lyrics.html'

class lyricsvip(GenericLyric):

    __title__ = 'LyricsVip'
    __version__ = '0.1'
    __authors__ = 'Alexandr Grigorcea <cahr.gr@gmail.com>'
    __desc__ = 'Download lyrics from lyricsvip.com'

    url = ""

    def get(self, artist, title):
        artist = quote(artist.replace(' ', '-'))
        title = re.sub('[\[\(]\s*(live|bonus|feat|ft).*?[\]\)]', '', title,
                       flags=re.I)
        title = quote(title.strip().replace(' ', '-'))

        self.url = URL_TEMPLATE % (artist, title)
        c.debug('lyricsvip URL: ' + self.url)

        try:
            content = urlopen(self.url).read()
            regexp = re.compile('<table class="tbl0">.*?</h2>(.*?)</td>',
                                re.DOTALL)
            m = regexp.search(content)
            if m:
                lyric =  m.group(1)
                regexp = re.compile ('\s*?<br\s*?/>\s*',re.DOTALL)
                lyric = regexp.sub('\n', lyric).strip()
                lyric = lyric.replace('&nbsp;', '')
                #lyric = lyric.replace('<br />', '\n').replace('\n\n','\n').replace('&nbsp;', '').strip()
                if lyric:
                    return lyric
        except:
            pass
        return None

    def get_webpage(self):
        return self.url
