# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import os

from core.common import ABS_PATH

def get_players():
    files = os.listdir(os.path.join(ABS_PATH, 'players'))
    players = [f[:-3] for f in files if f.endswith('.py') and f != '__init__.py']
    players.sort(key=str.lower)
    return players

def get_info(name):
    return __import__('players.'+name, fromlist=['players']).__dict__[name].__desc__

def get_class(name):
    return __import__('players.'+name, fromlist=['players']).__dict__[name]

def get_player(name, cg):
    return get_class(name)(cg)
