# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import logging
import re

from urllib2 import quote
from urllib2 import urlopen

from gettext import gettext as _

from tabs import GenericTab

c = logging.getLogger(__name__)

URL_TEMPLATE = "http://www.ultimate-guitar.com/tabs/%s/%s/%s_tab.htm"

class ultimateguitar(GenericTab):

    __title__ = 'Ultimate-Guitar.com'
    __version__ = '0.1'
    __authors__ = 'Jaap Broekhuizen <jaapz.b@gmail.com>, Jordi Hernandez <guitarboy000@gmail.com>'
    __desc__ = _('Download tablatures from Ultimate-Guitar.com')

    url = ""

    def get(self, artist, title):
        artist = quote(artist.replace(" ","_").lower().encode('utf-8'))
        title = quote(title.replace(" ","_").lower().encode('utf-8'))
        first_letter = artist[:1]

        self.url = URL_TEMPLATE % (first_letter, artist, title)
        c.debug('Ultimate-Guitar URL: ' + self.url)

        try:
            content = urlopen(self.url).read()
            regexp = re.compile ("<pre>(.*)</pre>", re.DOTALL)
            tabs = re.search(regexp, content).group(1).replace("\n\n\n\n", "")
            tabs = tabs.replace("<span>", "").replace("</span>", "")
            return tabs
        except:
            pass
        return None

    def get_webpage(self):
        return self.url
