# Copyright (C) 2009-2010 Gloobus Developers
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

import gtk
import config

from gettext import gettext as _

class AboutGloobus(gtk.AboutDialog):
    def __init__(self):
        super(AboutGloobus, self).__init__()
        self.set_logo_icon_name("covergloobus")
        self.set_name("CoverGloobus")
        self.set_comments(_("CoverGloobus. See what you're listening to\n from another point of view"))
        self.set_copyright("Copyright (C) 2010. Gloobus Developers")
        self.set_version(config.VERSION + "\nRevNo: " + config.BZRNO)
        self.set_website_label("http://www.gloobus.net")
        self.set_website("http://www.gloobus.net")

        self.set_authors(
            ["Jordi Puigdellivol Hernandez <guitarboy000@gmail.com>",
             "Jaap Broekhuizen <jaapz.b@gmail.com>",
             "Alexandr Grigorcea <cahr.gr@gmail.com>"])

    @staticmethod
    def run():
        about = AboutGloobus()
        super(AboutGloobus, about).run()
        about.destroy()
